import java.util.*;

class Person
{	
	public Person(String name)
	{
		this.name = name;
	}
	
	public String toString()
	{
		return name;
	}

	String name;
	
	// TUKAJ VSTAVITE DODATNE ATRIBUTE
	
}

public class GlavniProgram {

	// Pomozna funkcija, ki generira nakljucni graf poznanstev
	public static DirectedGraph createSocialNetwork(int numPersons, double friendshipProb)
	{
		Random generator = new Random();
		
		DirectedGraph diGraph = new DirectedGraph();
		GraphVertex[] vertices = new GraphVertex [numPersons];
		
		for (int i = 0; i < vertices.length; i++)
		{
			vertices[i] = new GraphVertex(new Person("Oseba" + (i+1)));
			diGraph.insertVertex(vertices[i]);
		}
		
		for (int i = 0; i < vertices.length-1; i++)
			for (int j = i+1; j < vertices.length; j++)
			{
				if (generator.nextDouble() < friendshipProb)
				{
					diGraph.insertEdge(vertices[i], vertices[j], "prijatelj");
					diGraph.insertEdge(vertices[j], vertices[i], "prijatelj");
				}
			}
				
		return diGraph;
	}
	
	//
	// NALOGE
	//
	
	// Implementirajte metodo, ki za vsako osebo v grafu izracuna stevilo njenih prijateljev
	public static void numFriends(DirectedGraph diGraph)
	{
		//TUKAJ VSTAVITE SVOJO KODO
	}
	
	// Implementirajte metodo int chain(DirectedGraph diGraph, String nameA, String nameB), 
	// ki vrne dolzino najkrajse "verige" poznanstev od osebe nameA do osebe nameB. 
	// Ce se osebi poznata, je dolzina verige 1. 
	// Ce se ne poznata, imata pa skupnega prijatelja, je dolzina verige 2 in tako naprej. 
	// Ce med osebama nameA in nameB ni poti v grafu poznanstev, funkcija vrne -1.
	public static int chain(DirectedGraph diGraph, String nameA, String nameB)
	{
		//TUKAJ VSTAVITE SVOJO KODO
		
		return -1;
	}
	
	// Implementirajte metodo void wedding(DirectedGraph diGraph, String nameA, String nameB, int radius), 
	// ki izpise seznam povabljencev na poroko med osebama nameA in nameB. Pri tem argument "radius" doloca krog potencialnih povabljencev. 
	// Ce je radius=1, bodo na poroko povabljeni samo neposredni prijatelji mladoporocencev. 
	// Ce je radius=2, bodo povabljeni tudi neposredni prijatelji neposrednih prijateljev mladoporocencev in tako naprej. 
	// Pri izracunu upostevajte, da bo vsaka oseba povabljena samo enkrat, kljub temu, da ustreza razlicnim kriterijem za povabilo.
	public static void wedding(DirectedGraph diGraph, String nameA, String nameB, int radius)
	{
		//TUKAJ VSTAVITE SVOJO KODO
	}
	
	
	// Implementirajte metodo void clique(DirectedGraph diGraph), ki poisce (in izpise) najvecjo skupino ljudi, v kateri se vsi poznajo med seboj
	// (drugace povedano, vsak je prijatelj z vsakim).
	public static void clique(DirectedGraph diGraph)
	{
		//TUKAJ VSTAVITE SVOJO KODO
	}
	
	// Implementirajte metodo void vip(DirectedGraph diGraph), ki izbere (in izpise) minimalno podmnoico oseb, za katere velja, 
	// da (skupinsko gledano) poznajo vse osebe v grafu. 
	// Drugace povedano, za vsako osebo v grafu velja, da je bodisi element izbrane podmnozice bodisi je neposredni znanec neke osebe iz izbrane podmnozice.
	public static void vip(DirectedGraph diGraph)
	{
		//TUKAJ VSTAVITE SVOJO KODO
	}
	
	public static void main(String[] args) 
	{
		DirectedGraph diGraph = createSocialNetwork(50, 0.2);
		diGraph.print();
		
		numFriends(diGraph);
		
		System.out.println("Veriga poznanstev med Osebo1 in Osebo5 je dolga " + chain(diGraph, "Oseba1", "Oseba5"));
		wedding(diGraph, "Oseba2", "Oseba9", 2);
		
		clique(diGraph);
		
		vip(diGraph);
	}

}
